import * as is from 'is_js'

export default function (input) {
  if (is.function(input)) {
    let object = input(this)
    return onObject.call(this, object) // @TODO: what to do here ?
  }

  if (is.object(input)) {
    let object = input
    return onObject.call(this, object, {unshiftSelf: true})
  }
  return this
}

function onObject(object, {unshiftSelf} = {}) {
  let loading = this.loading
  // iterate over entries
  for (let [name, action] of Object.entries(object)) {
    // update loaders
    loading(name, false)

    this[name] = (...params) => {
      let result = unshiftSelf ? action(this, ...params) : action(...params)

      let promise = result instanceof Promise
      if (promise) {
        loading(name, true)

        result.then(_ => {
          loading(name, false)
          return _
        })
          .catch(_ => {
            loading(name, false)
            return _
          })
        return result
      }
      return result
    }
  }
  return this
}
