import {default as set} from './set'
import {default as get} from './get'
import {default as has} from './has'
import {default as merge} from './merge'

import {default as clone} from './clone'

import {default as is} from './is'

import {default as actions} from './actions'
import {default as getters} from './getters'
import {default as setters} from './setters'
import {default as loading} from './loading'
import {default as defaultState} from './defaultState'
import {default as initialState} from './initialState'
import {default as reset} from './reset'
import {default as do_} from './do'

const cenote=() => {

  let instance={}

  let data={
    state: {},
    defaultState: {},
    loaders: {}
  }



  Object.setPrototypeOf(instance,{
    set: set(instance,data),
    get: get(instance,data),
    has: has(instance,data),
    is: is(instance,data),
    merge: merge(instance,data),
    clone: clone(instance,data),

    actions: actions(instance,data),
    getters: getters(instance,data),
    do: do_(instance,data),
    setters: setters(instance,data),
    loading: loading(instance,data),
    defaultState: defaultState(instance,data),
    initialState: initialState(instance,data),
    reset: reset(instance,data),
  })

  return instance
}

if (typeof global!=undefined) {
  global.cenote=cenote
}
if (typeof window!=undefined) {
  window.cenote=cenote
}

export default cenote
