import * as _cloneDeep from 'lodash.clonedeep'
import * as _get from 'lodash.get'

export default (instance,data) => (...params) => {
  switch (params.length) {
    case 0: {
      let initialState=data.initialState
      if (typeof initialState=='function') {
        instance.set(initialState())
      } else {
        let cloned=_cloneDeep(initialState)
        instance.set(cloned)
      }
    }
    case 1: {
      let path=params[0]
      let initialState=_get(data.initialState,path)
      let cloned=_cloneDeep(initialState)
      instance.set(path,cloned)
    }
  }
  return instance
}
