require('../../dist/es5')
/* eslint-disable */

describe('clone',function() {
  it('clone',function(done) {
    let store=window.cenote()
      .set({
        name: {foo: {test: 5}}
      })
    if (store.get('name.foo.test')!=store.clone('name.foo.test')) {
      return done(`store.get('name.foo.test') != store.clone('name.foo.test')`)
    }

    if (store.get('name')==store.clone('name')) {
      return done(`store.get('name') == store.clone('name')`)
    }

    if (store.get('name').foo!=store.clone('name').foo) {
      return done(`store.get('name').foo != store.clone('name').foo`)
    }

    if (store.get('name.foo')===store.get('foo.name')) {
      return done(`store.get('name.foo')===store.get('foo.name')`)
    }

    if (store.get('name')===store.clone('name')) {
      return done(`store.get('name') === store.clone('name')`)
    }
    return done()
  })

})

describe('clone deep',function() {
  it('clone',function(done) {

    let store=window.cenote()
      .set({
        name: {foo: {test: 5}}
      })

    if (store.get('name').foo===store.clone.deep('name').foo) {
      return done(`store.get('name').foo === store.clone('name').foo`)
    }

    if (store.get('name').foo==store.clone.deep('name').foo) {
      return done(`store.get('name').foo == store.clone('name').foo`)
    }

    if (store.get('name').foo.test!=store.clone.deep('name').foo.test) {
      return done(`store.get('name').foo.test != store.get('name').foo.test`)
    }

    return done()
  })

})